<?php

/**

 * @package     Joomla.Site

 * @subpackage  com_content

 *

 * @copyright   Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.

 * @license     GNU General Public License version 2 or later; see LICENSE.txt

 */



defined('_JEXEC') or die;



JHtml::addIncludePath(JPATH_COMPONENT . '/helpers');



JHtml::_('behavior.caption');

?>
<?php if ($this->params->get('show_page_heading')) : ?>

<header>
  <?php elseif ($this->params->get('show_category_title', 1) or $this->params->get('page_subheading')) : ?>
  <header>
    <?php elseif ($this->params->get('show_cat_tags', 1) && !empty($this->category->tags->itemTags)) : ?>
    <header>
      <?php elseif ($this->params->get('show_description', 1) || $this->params->def('show_description_image', 1)) : ?>
      <header>
        <?php elseif (empty($this->lead_items) && empty($this->link_items) && empty($this->intro_items)) : ?>
        <header>
          <?php endif; ?>
          <?php if ($this->params->get('show_page_heading')) : ?>
          <div class="page-header">
            <h1> <?php echo $this->escape($this->params->get('page_heading')); ?> </h1>
          </div>
          <?php endif; ?>
          <?php if ($this->params->get('show_category_title', 1) or $this->params->get('page_subheading')) : ?>
          <h2> <?php echo $this->escape($this->params->get('page_subheading')); ?>
            <?php if ($this->params->get('show_category_title')) : ?>
            <span class="subheading-category"><?php echo $this->category->title; ?></span>
            <?php endif; ?>
          </h2>
          <?php endif; ?>
          <?php if ($this->params->get('show_cat_tags', 1) && !empty($this->category->tags->itemTags)) : ?>
          <?php $this->category->tagLayout = new JLayoutFile('joomla.content.tags'); ?>
          <?php echo $this->category->tagLayout->render($this->category->tags->itemTags); ?>
          <?php endif; ?>
          <?php if ($this->params->get('show_description', 1) || $this->params->def('show_description_image', 1)) : ?>
          <div class="category-desc clearfix cf">
            <?php if ($this->params->get('show_description_image') && $this->category->getParams()->get('image')) : ?>
            <img src="<?php echo $this->category->getParams()->get('image'); ?>" alt="<?php echo htmlspecialchars($this->category->getParams()->get('image_alt'), ENT_COMPAT, 'UTF-8'); ?>"/>
            <?php endif; ?>
            <?php if ($this->params->get('show_description') && $this->category->description) : ?>
            <?php echo JHtml::_('content.prepare', $this->category->description, '', 'com_content.category'); ?>
            <?php endif; ?>
          </div>
          <?php endif; ?>
          <?php if (empty($this->lead_items) && empty($this->link_items) && empty($this->intro_items)) : ?>
          <?php if ($this->params->get('show_no_articles', 1)) : ?>
          <p><?php echo JText::_('COM_CONTENT_NO_ARTICLES'); ?></p>
          <?php endif; ?>
          <?php endif; ?>
          <?php if ($this->params->get('show_page_heading')) : ?>
        </header>
        <?php elseif ($this->params->get('show_category_title', 1) or $this->params->get('page_subheading')) : ?>
      </header>
      <?php elseif ($this->params->get('show_cat_tags', 1) && !empty($this->category->tags->itemTags)) : ?>
    </header>
    <?php elseif ($this->params->get('show_description', 1) || $this->params->def('show_description_image', 1)) : ?>
  </header>
  <?php elseif (empty($this->lead_items) && empty($this->link_items) && empty($this->intro_items)) : ?>
</header>
<?php endif; ?>
<?php $leadingcount = 0; ?>
<?php if (!empty($this->lead_items)) : ?>
<section class="items-leading clearfix cf">
  <?php foreach ($this->lead_items as &$item) : ?>
  <article class="news_item product_feature leading-<?php echo $leadingcount; ?><?php echo $item->state == 0 ? ' system-unpublished' : null; ?>" itemprop="blogPost" itemscope itemtype="https://schema.org/BlogPosting">
    <?php

					$this->item = & $item;

					echo $this->loadTemplate('item');

					?>
  </article>
  <?php $leadingcount++; ?>
  <?php endforeach; ?>
</section>
<!-- end items-leading -->

<?php endif; ?>
<?php

	$introcount = (count($this->intro_items));

	$counter = 0;

	?>
<?php if (!empty($this->intro_items)) : ?>
<section class="content cf">
  <?php foreach ($this->intro_items as $key => &$item) : ?>
  <?php $rowcount = ((int) $key % (int) $this->columns) + 1; ?>
  <?php if ($rowcount == 1) : ?>
  <?php $row = $counter / $this->columns; ?>
  <div class="row items-row <?php echo 'row-' . $row; ?> row-fluid clearfix cf">
    <?php endif; ?>
    <article class="news_item product span<?php echo round((12 / $this->columns)); ?> column<?php echo round((12 / $this->columns)); ?> item " itemprop="blogPost" itemscope itemtype="https://schema.org/BlogPosting" >
      <div class="container">
        <?php

					$this->item = & $item;

					echo $this->loadTemplate('subitem');

					?>
        
        <!-- end item -->
        
        <?php $counter++; ?>
      </div>
    </article>
    <!-- end span -->
    
    <?php if (($rowcount == $this->columns) or ($counter == $introcount)) : ?>
  </div>
  <!-- end row -->
  
  <?php endif; ?>
  <?php endforeach; ?>
</section>
<?php endif; ?>
<?php if (!empty($this->link_items)) : ?>
<section class="items-more"> <?php echo $this->loadTemplate('links'); ?> </section>
<?php endif; ?>
<?php if (!empty($this->children[$this->category->id]) && $this->maxLevel != 0) : ?>
<section class="cat-children">
  <?php if ($this->params->get('show_category_heading_title_text', 1) == 1) : ?>
  <h3> <?php echo JText::_('JGLOBAL_SUBCATEGORIES'); ?> </h3>
  <?php endif; ?>
  <?php echo $this->loadTemplate('children'); ?> </section>
<?php endif; ?>
<?php if (($this->params->def('show_pagination', 1) == 1 || ($this->params->get('show_pagination') == 2)) && ($this->pagination->get('pages.total') > 1)) : ?>
<div class="pagination">
  <?php if ($this->params->def('show_pagination_results', 1)) : ?>
  <p class="counter pull-right"> <?php echo $this->pagination->getPagesCounter(); ?> </p>
  <?php endif; ?>
  <?php echo $this->pagination->getPagesLinks(); ?> </div>
<?php endif; ?>
